% function [clean_images, frames] = Fake_Images()

box = 0.25*ones(32,32);
% for ii = 1:32
%    for jj = 1:32
%        if(mod(ii+jj,2))
%            box([ii],[jj]) = 0.3;
%        end
%    end
% end

pos = 112:143;
for ii = 1:8
    background = 0.75*ones(256,256);
    background([pos],[pos]) = box;
    indexed = gray2ind(background,256);
    if (ii == 1)
        synthetic = background;
        syntheticInd = indexed;
    else
        synthetic = cat(3,synthetic,background);
        syntheticInd = cat(3,syntheticInd,indexed);
    end
    pos = pos + 8;
end

up = pos - 8;
for ii = 1:16
    background = 0.75*ones(256,256);
    background([up],[pos]) = box;
    indexed = gray2ind(background,256);
    synthetic = cat(3,synthetic,background);
    syntheticInd = cat(3,syntheticInd,indexed);
    up = up - 8;
end

left = pos - 8;
for ii = 1:16
    background = 0.75*ones(256,256);
    background([up],[left]) = box;
    indexed = gray2ind(background,256);
    synthetic = cat(3,synthetic,background);
    syntheticInd = cat(3,syntheticInd,indexed);
    left = left - 8;
end

down = up + 8;
right = left + 8;
for ii = 1:8
    background = 0.75*ones(256,256);
    background([down],[right]) = box;
    indexed = gray2ind(background,256);
    synthetic = cat(3,synthetic,background);
    syntheticInd = cat(3,syntheticInd,indexed);
    down = down + 8;
    right = right + 8;
end

%for ii = 1:48
%    colormap(jet(256))
%    image(syntheticInd(:,:,ii))
%    truesize
%    pause(0.1)
%end

clean_images = synthetic;
frames = 48;
for ii = 1:frames
    A = mat2gray(clean_images(:,:,ii));
    [A,map] = gray2ind(A,256);
    filename = sprintf('square%d.jpg',ii);
    imwrite(A,map,filename,'jpeg')
end
