clear
clc 
close all


nn = 4; %number of images in the sequence
for ii = 1:nn
s = sprintf('gbe%d.jpg',ii);
[input,map] = imread(s,'jpeg');
dummy = rgb2ind(input,gray(256));
E(:,:,ii) = dummy;
end
% [input,map] = imread('1.jpg','jpeg');
% dummy = rgb2ind(input,gray(256));
% E(:,:,1) = dummy;
% [input,map] = imread('gb6.jpg','jpeg');
% dummy = rgb2ind(input,gray(256));
% E(:,:,2) = dummy;

[M, N, sizek]=size(E);
%M = number of rows (indexed by ii)
%N = number of columsn (indexed by jj)
u = zeros(M,N);
v = zeros(M,N);

alpha = 20; %weighting factor
num_its = 8; %number of iterations

% xkern(:,:,1) = (1/4)*[-1,1;-1,1];
% xkern(:,:,2) = (1/4)*[-1,1;-1,1];
% ykern(:,:,1) = (1/4)*[-1,-1;1,1];
% ykern(:,:,2) = (1/4)*[-1,-1;1,1];
% tkern(:,:,1) = (1/4)*[-1,-1;-1,-1];
% tkern(:,:,2) = (1/4)*[1,1;1,1];
%LaplKern = [1/12,1/6,1/12;1/6,-1,1/6;1/12,1/6,1/12];

% Ex = convn(image_seq,xkern);
% Ey = convn(image_seq,ykern);
% Et = convn(image_seq,tkern);
for kk = 1:sizek-1
Ex = zeros(M,N);
Ey = Ex;
Et = Ey;
for ii = 1:M
    for jj = 1:N
        %Determine the region of the image
        if ii == M
            if jj == N
                region = 4; %bottom right corner
            else
                region = 2; %bottom row
            end
        else
            if jj ==N
                region = 3; %right most column
            else
                region = 1; %somewhere else in the image
            end
        end
        switch region
            case 1 %normal calculation
                Ex(ii,jj) = (1/4)*(E(ii+1,jj+1,kk)-E(ii+1,jj,kk)+E(ii,jj+1,kk)-E(ii,jj,kk)...
                    +E(ii+1,jj+1,kk+1)-E(ii+1,jj,kk+1)+E(ii,jj+1,kk+1)-E(ii,jj,kk+1));
                Ey(ii,jj) = (1/4)*(E(ii,jj,kk)-E(ii+1,jj,kk)+E(ii,jj+1,kk)-E(ii+1,jj+1,kk)...
                    +E(ii,jj,kk+1)-E(ii+1,jj,kk+1)+E(ii,jj+1,kk+1)-E(ii+1,jj+1,kk+1));
                Et(ii,jj) = (1/4)*(E(ii+1,jj,kk+1)-E(ii+1,jj,kk)+E(ii,jj,kk+1)-E(ii,jj,kk)...
                    +E(ii+1,jj+1,kk+1)-E(ii+1,jj+1,kk)+E(ii,jj+1,kk+1)-E(ii,jj+1,kk));

            case 2 %bottom row, remove ii+1 indexes
                Ex(ii,jj) = (1/4)*(E(ii,jj+1,kk)-E(ii,jj,kk)+E(ii,jj+1,kk)-E(ii,jj,kk)...
                    +E(ii,jj+1,kk+1)-E(ii,jj,kk+1)+E(ii,jj+1,kk+1)-E(ii,jj,kk+1));
                Ey(ii,jj) = (1/4)*(E(ii,jj,kk)-E(ii,jj,kk)+E(ii,jj+1,kk)-E(ii,jj+1,kk)...
                    +E(ii,jj,2)-E(ii,jj,kk+1)+E(ii,jj+1,kk+1)-E(ii,jj+1,kk+1));
                Et(ii,jj) = (1/4)*(E(ii,jj,kk+1)-E(ii,jj,kk)+E(ii,jj,kk+1)-E(ii,jj,kk)...
                    +E(ii,jj+1,kk+1)-E(ii,jj+1,kk)+E(ii,jj+1,kk+1)-E(ii,jj+1,kk));
             
            case 3 %right most row, remove jj+1 indexes
                Ex(ii,jj) = (1/4)*(E(ii+1,jj,kk)-E(ii+1,jj,kk)+E(ii,jj,kk)-E(ii,jj,kk)...
                    +E(ii+1,jj,kk+1)-E(ii+1,jj,kk+1)+E(ii,jj,kk+1)-E(ii,jj,kk+1));
                Ey(ii,jj) = (1/4)*(E(ii,jj,kk)-E(ii+1,jj,kk)+E(ii,jj,kk)-E(ii+1,jj,kk)...
                    +E(ii,jj,kk+1)-E(ii+1,jj,kk+1)+E(ii,jj,kk+1)-E(ii+1,jj,kk+1));
                Et(ii,jj) = (1/4)*(E(ii+1,jj,kk+1)-E(ii+1,jj,kk)+E(ii,jj,kk+1)-E(ii,jj,kk)...
                    +E(ii+1,jj,kk+1)-E(ii+1,jj,kk)+E(ii,jj,kk+1)-E(ii,jj,kk));
                
            case 4 %bottom right corner remove ii+1 and jj+1 indexes
                Ex(ii,jj) = (1/4)*(E(ii,jj,kk)-E(ii,jj,kk)+E(ii,jj,kk)-E(ii,jj,kk)...
                    +E(ii,jj,kk+1)-E(ii,jj,kk+1)+E(ii,jj,kk+1)-E(ii,jj,kk+1));
                Ey(ii,jj) = (1/4)*(E(ii,jj,kk)-E(ii,jj,kk)+E(ii,jj,kk)-E(ii,jj,kk)...
                    +E(ii,jj,kk+1)-E(ii,jj,kk+1)+E(ii,jj,kk+1)-E(ii,jj,kk+1));
                Et(ii,jj) = (1/4)*(E(ii,jj,kk+1)-E(ii,jj,kk)+E(ii,jj,kk+1)-E(ii,jj,kk)...
                    +E(ii,jj,kk+1)-E(ii,jj,kk)+E(ii,jj,kk+1)-E(ii,jj,kk));

        end
    end
end

for nn = 1:num_its
    for ii = 1:M 
        for jj = 2:N  
            %select region within the image
            %  1------2------3
            %  ---------------
            %  7------8------9
            %  ---------------
            %  4------5------6
            if ii == 1 
                if jj == 1
                    region = 1; %top left corner
                elseif jj == N
                    region = 3; %top right corner
                else
                    region = 2; %top row
                end
            elseif ii == M
                if jj == 1
                    region = 4; %bottom left corner
                elseif jj == N
                    region = 6; %bottom right corner
                else
                    region = 5; %bottom row
                end
            else 
                if jj == 1
                    region = 7; %left most column
                elseif jj == N
                    region = 9; %right most column
                else
                    region = 8; %somewhere in the middle
                end
            end
         switch region
             case 1 %top left corner, remove ii-1 and jj-1
                 ubar = (1/6)*(u(ii,jj)+u(ii,jj+1)+u(ii+1,jj)+u(ii,jj))+...
                     (1/12)*(u(ii,jj)+u(ii,jj+1)+u(ii+1,jj+1)+u(ii+1,jj));
                 vbar = (1/6)*(v(ii,jj)+v(ii,jj+1)+v(ii+1,jj)+v(ii,jj))+...
                     (1/12)*(v(ii,jj)+v(ii,jj+1)+v(ii+1,jj+1)+v(ii+1,jj));

             case 2 %top row, remove ii-1
                 ubar = (1/6)*(u(ii,jj)+u(ii,jj+1)+u(ii+1,jj)+u(ii,jj-1))+...
                     (1/12)*(u(ii,jj-1)+u(ii,jj+1)+u(ii+1,jj+1)+u(ii+1,jj-1));
                 vbar = (1/6)*(v(ii,jj)+v(ii,jj+1)+v(ii+1,jj)+v(ii,jj-1))+...
                     (1/12)*(v(ii,jj-1)+v(ii,jj+1)+v(ii+1,jj+1)+v(ii+1,jj-1));

             case 3 %top right corner, remove ii-1 and jj+1
                 ubar = (1/6)*(u(ii,jj)+u(ii,jj)+u(ii+1,jj)+u(ii,jj-1))+...
                     (1/12)*(u(ii,jj-1)+u(ii,jj)+u(ii+1,jj)+u(ii+1,jj-1));
                 vbar = (1/6)*(v(ii,jj)+v(ii,jj)+v(ii+1,jj)+v(ii,jj-1))+...
                     (1/12)*(v(ii,jj-1)+v(ii,jj)+v(ii+1,jj)+v(ii+1,jj-1));

             case 4 %bottom left corner,remove ii+1 and jj-1
                 ubar = (1/6)*(u(ii-1,jj)+u(ii,jj+1)+u(ii,jj)+u(ii,jj))+...
                     (1/12)*(u(ii-1,jj)+u(ii-1,jj+1)+u(ii,jj+1)+u(ii,jj));
                 vbar = (1/6)*(v(ii-1,jj)+v(ii,jj+1)+v(ii,jj)+v(ii,jj))+...
                     (1/12)*(v(ii-1,jj)+v(ii-1,jj+1)+v(ii,jj+1)+v(ii,jj));

             case 5 %bottom row, remove ii+1
                 ubar = (1/6)*(u(ii-1,jj)+u(ii,jj+1)+u(ii,jj)+u(ii,jj-1))+...
                     (1/12)*(u(ii-1,jj-1)+u(ii-1,jj+1)+u(ii,jj+1)+u(ii,jj-1));
                 vbar = (1/6)*(v(ii-1,jj)+v(ii,jj+1)+v(ii,jj)+v(ii,jj-1))+...
                     (1/12)*(v(ii-1,jj-1)+v(ii-1,jj+1)+v(ii,jj+1)+v(ii,jj-1));

             case 6 %bottom right corner, remove ii+1, jj+1
                 ubar = (1/6)*(u(ii-1,jj)+u(ii,jj)+u(ii,jj)+u(ii,jj-1))+...
                     (1/12)*(u(ii-1,jj-1)+u(ii-1,jj)+u(ii,jj)+u(ii,jj-1));
                 vbar = (1/6)*(v(ii-1,jj)+v(ii,jj)+v(ii,jj)+v(ii,jj-1))+...
                     (1/12)*(v(ii-1,jj-1)+v(ii-1,jj)+v(ii,jj)+v(ii,jj-1));

             case 7 %left most column, remove jj-1
                 ubar = (1/6)*(u(ii-1,jj)+u(ii,jj+1)+u(ii+1,jj)+u(ii,jj))+...
                     (1/12)*(u(ii-1,jj)+u(ii-1,jj+1)+u(ii+1,jj+1)+u(ii+1,jj));
                 vbar = (1/6)*(v(ii-1,jj)+v(ii,jj+1)+v(ii+1,jj)+v(ii,jj))+...
                     (1/12)*(v(ii-1,jj)+v(ii-1,jj+1)+v(ii+1,jj+1)+v(ii+1,jj));

             case 8 %somewhere in the middle, normal case
                 ubar = (1/6)*(u(ii-1,jj)+u(ii,jj+1)+u(ii+1,jj)+u(ii,jj-1))+...
                     (1/12)*(u(ii-1,jj-1)+u(ii-1,jj+1)+u(ii+1,jj+1)+u(ii+1,jj-1));
                 vbar = (1/6)*(v(ii-1,jj)+v(ii,jj+1)+v(ii+1,jj)+v(ii,jj-1))+...
                     (1/12)*(v(ii-1,jj-1)+v(ii-1,jj+1)+v(ii+1,jj+1)+v(ii+1,jj-1));

             case 9 %right most column, remove jj+1
                 ubar = (1/6)*(u(ii-1,jj)+u(ii,jj)+u(ii+1,jj)+u(ii,jj-1))+...
                     (1/12)*(u(ii-1,jj-1)+u(ii-1,jj)+u(ii+1,jj)+u(ii+1,jj-1));
                 vbar = (1/6)*(v(ii-1,jj)+v(ii,jj)+v(ii+1,jj)+v(ii,jj-1))+...
                     (1/12)*(v(ii-1,jj-1)+v(ii-1,jj)+v(ii+1,jj)+v(ii+1,jj-1));
         end
        %-------------------------
        %compute alpha
        lambda = (Ex(ii,jj)*ubar+Ey(ii,jj)*vbar+Et(ii,jj))/...
                (alpha^2 +(Ex(ii,jj))^2+(Ey(ii,jj))^2);
        %update u(ii,jj) and v(ii,jj)
        u(ii,jj) = ubar-lambda*Ex(ii,jj);
        v(ii,jj) = vbar-lambda*Ey(ii,jj);
        end
    end
end
end

clear E Et Ex Ey
dd = 5;
[xx,yy] = meshgrid(1:dd:N,1:dd:M); %creates grid                                              
a = u(1:dd:M,1:dd:N);
b = v(1:dd:M,1:dd:N);
axis ij
quiver(xx,-yy,-b,a,'k')


