clear
clc 
close all


nn = 4; %number of images in the sequence
for ii = 1:nn
s = sprintf('gbe%d.jpg',ii);
[input,map] = imread(s,'jpeg');
dummy = rgb2ind(input,gray(256));
E(:,:,ii) = dummy;
end
% [input,map] = imread('1.jpg','jpeg');
% dummy = rgb2ind(input,gray(256));
% E(:,:,1) = dummy;
% [input,map] = imread('gb6.jpg','jpeg');
% dummy = rgb2ind(input,gray(256));
% E(:,:,2) = dummy;


alpha = 20; %weighting factor
num_its = 8; %number of iterations


xkern(:,:,1) = (1/4)*[-1,1;-1,1];
xkern(:,:,2) = xkern(:,:,1);
ykern(:,:,1) = (1/4)*[1,1;-1,-1];
ykern(:,:,2) = ykern(:,:,1);
tkern(:,:,1) = (1/4)*[-1,-1;-1,-1];
tkern(:,:,2) = -tkern(:,:,1);

LaplKern = [1/12,1/6,1/12;1/6,-1,1/6;1/12,1/6,1/12];

Ex = convn(E,xkern,'valid');
Ey = convn(E,ykern,'valid');
Et = convn(E,tkern,'valid');

[M, N, sizek]=size(Ex);
%M = number of rows (indexed by ii)
%N = number of columsn (indexed by jj)
u = zeros(M,N);
v = zeros(M,N);

for tt = 1:nn-1
    for xx = 1:num_its
        ubar = convn(u,LaplKern,'same');
        vbar = convn(v,LaplKern,'same');
        %compute alpha
        lambda = (Ex(:,:,tt).*ubar+Ey(:,:,tt).*vbar+Et(:,:,tt))./...
            (alpha^2 + Ex(:,:,tt).*Ex(:,:,tt)+ Ey(:,:,tt).*Ey(:,:,tt));
        %update u and v
        u = ubar-lambda.*Ex(:,:,tt);
        v = vbar-lambda.*Ey(:,:,tt);
    end
end

clear E Et Ex Ey
dd = 5;
[xx,yy] = meshgrid(1:dd:N,1:dd:M); %creates grid                                              
a = u(1:dd:M,1:dd:N);
b = v(1:dd:M,1:dd:N);
axis ij
quiver(xx,-yy,-b,a,'k')


