clear
clc
close all


nn = 4; %number of images in the sequence
for ii = 1:nn
    s = sprintf('gb%d.jpg',ii);
    [input,map] = imread(s,'jpeg');
    dummy = rgb2ind(input,gray(256));
    E(:,:,ii) = double(dummy);
end

[M, N, sizek]=size(E);
u = zeros(M,N);
v = zeros(M,N);

ubar = u;
vbar = v;

alpha = 10; %weighting factor
num_its = 32; %number of iterations
ivv = 2:(M-1);
ivm =  ivv-1;
ivp = ivv+1;

jvv = 2:(N-1);
jvm = jvv-1;
jvp = jvv+1;


for kk = 1:sizek-1
    
    fprintf('kk=%d\n',kk);
    
    Ex = zeros(M,N);
    Ey = Ex;
    Et = Ey;
    Ex(ivv,jvv) = ( (E(ivp,jvp,kk) - E(ivp,jvv,kk)) ...
        + (E(ivv,jvp,kk) - E(ivv,jvv,kk)) ...
        + (E(ivp,jvp,kk+1) - E(ivp,jvv,kk+1)) ...
        + (E(ivv,jvp,kk+1) - E(ivv,jvv,kk+1)) )/4;
    Ey(ivv,jvv) = ( ...
            (E(ivv,jvv,kk) - E(ivp,jvv,kk)) ...
        + (E(ivv,jvp,kk) - E(ivp,jvp,kk)) ...
        + (E(ivv,jvv,kk+1) - E(ivp,jvv,kk+1)) ...
        + (E(ivv,jvp,kk+1) - E(ivp,jvp,kk+1 )) ...
        )/4;
    Et(ivv,jvv) = ( ...
          + (E(ivp,jvp,kk+1) - E(ivp,jvp,kk)) ...
          + (E(ivv,jvp,kk+1) - E(ivv,jvp,kk)) ...
          + (E(ivp,jvv,kk+1) - E(ivp,jvv,kk)) ...
          + (E(ivv,jvv,kk+1) - E(ivv,jvv,kk)) ...
        )/4;
    lastu = 1e6*ones(M,N);
    lastv = lastu ;
    % one percent tolerance
    nn = 0;
    while( ... 
        norm(lastu - ubar,'fro')/max(1e-12,norm(lastu,'fro'))  ...
        + norm(lastv - vbar,'fro')/max(1e-12,norm(lastv,'fro')) > 5e-2)
    tol = norm(lastu - ubar,'fro')/max(1e-12,norm(lastu,'fro'))  ...
        + norm(lastv - vbar,'fro')/max(1e-12,norm(lastv,'fro'));
    nn = nn+1;
    lastu = ubar;
    lastv = vbar;
        fprintf('kk,nn=%d, %d of %d, %d; tol=%e\n', kk, nn, sizek, num_its,tol);
        ubar(ivv,jvv) = (u(ivm,jvv) + u(ivv,jvp) + u(ivp,jvv) + u(ivv,jvm))/6 ...
            + (u(ivm,jvm) + u(ivm,jvp) + u(ivp,jvp) + u(ivp,jvm))/12;
        
        vbar(ivv,jvv) = (v(ivm,jvv) + v(ivv,jvp) + v(ivp,jvv) + v(ivv,jvm))/6 ...
            + (v(ivm,jvm) + v(ivm,jvp) + v(ivp,jvp) + v(ivp,jvm))/12;
        
        lambda = ((Ex .* ubar) + (Ey .* vbar) + Et) ./ ( alpha^2 + (Ex .^2) + (Ey.^2));
        u = ubar - (lambda .* Ex);
        v = vbar - (lambda .* Ey);
        
    end
end

clear E Et Ex Ey
dd = 5;
[xx,yy] = meshgrid(1:dd:N,1:dd:M); %creates grid
a = u(1:dd:M,1:dd:N);
b = v(1:dd:M,1:dd:N);
axis ij
quiver(xx,-yy,b,a,'k')


