clear
clc
close all

dd = 10;
alpha = 20; %weighting factor
num_its = 16; %number of iterations

%===frames 1-4===================
nn = 4;
for ii = 1:nn
    s = sprintf('blimpe%d.jpg',ii);
    [input,map] = imread(s,'jpeg');
    dummy = rgb2ind(input,gray(256));
    E(:,:,ii) = dummy;
end
    [M, N, sizek]=size(E);

u = zeros(M,N);
v = zeros(M,N);

[uu,vv]=hsof(E,num_its,alpha,u,v);

[M, N, sizek]=size(E);
[xx,yy] = meshgrid(1:dd:N,1:dd:M); %creates grid
a = uu(1:dd:M,1:dd:N);
b = vv(1:dd:M,1:dd:N);
axis ij
quiver(xx,-yy,-b,a,'k')

%===frames 5-8===================
%save previous velocity vectors for initial velocities in next sequence
u = uu;
v = vv;
nn = 4;
for ii = 1:nn
    s = sprintf('blimpe%d.jpg',ii+4);
    [input,map] = imread(s,'jpeg');
    dummy = rgb2ind(input,gray(256));
    E(:,:,ii) = dummy;
end

[uu,vv]=hsof(E,num_its,alpha,u,v);

[M, N, sizek]=size(E);
figure(2)
[xx,yy] = meshgrid(1:dd:N,1:dd:M); %creates grid
a = uu(1:dd:M,1:dd:N);
b = vv(1:dd:M,1:dd:N);
axis ij
quiver(xx,-yy,-b,a,'k')
% 
%===frames 9-12===================
%save previous velocity vectors for initial velocities in next sequence
u = uu;
v = vv;

nn = 4;
for ii = 1:nn
    s = sprintf('blimpe%d.jpg',ii+8);
    [input,map] = imread(s,'jpeg');
    dummy = rgb2ind(input,gray(256));
    E(:,:,ii) = dummy;
end

[uu,vv]=hsof(E,num_its,alpha,u,v);

[M, N, sizek]=size(E);
figure(3)
[xx,yy] = meshgrid(1:dd:N,1:dd:M); %creates grid
a = uu(1:dd:M,1:dd:N);
b = vv(1:dd:M,1:dd:N);
axis ij
quiver(xx,-yy,-b,a,'k')
% 
