%Josh Clanton
%ELEC 6430
%2/24/05

%This is an algorithm to attempt edge detection using the sobel operator
clear
clc
close all
H1 = [-1,0,1;-2,0,2;-1,0,1];
H2 = H1';
gt = 100; %gradient threshold

%==============grayscale edge detection===================
camera = imread('camera.tif','tiff');
map = colormap;
I = mat2gray(camera);
[camera,map] = gray2ind(I,256);

Gx = conv2(camera,H1);
Gy = conv2(camera,H2);
for ii = 1:size(Gx,1)
    for jj = 1:size(Gx,2)
        mag = sqrt((Gx(ii,jj))^2+(Gy(ii,jj))^2);
        if mag>gt
            gmn(ii,jj) = 0;
        else
            gmn(ii,jj) = 255;
        end
    end
end

figure(1)
subplot(2,1,1)
colormap(map)
image(camera)
title('original grayscale image')
subplot(2,1,2)
image(gmn)
title('detected edges')
truesize

%==============color edge detection===================
[input,mapi] = imread('lillies.jpg','jpeg');

%perform the sobel operator on each color layer
for ll = 1:3
Gx = conv2(input(:,:,ll),H1);
Gy = conv2(input(:,:,ll),H2);
for ii = 1:size(Gx,1)
    for jj = 1:size(Gx,2)
        gmn(ii,jj) = sqrt((Gx(ii,jj))^2+(Gy(ii,jj))^2);
    end
end
image_grad(:,:,ll) = gmn;
end

%now average the three colors and test threshold
for ii = 1:size(image_grad,1)
    for jj = 1:size(image_grad,2)
        mean = (1/3)*(image_grad(ii,jj,1)+image_grad(ii,jj,2)+image_grad(ii,jj,3));
        if mean > gt
            output(ii,jj) = 0;
        else
            output(ii,jj) = 255;
        end
    end
end
figure(2)
colormap(mapi)
subplot(2,1,1)
image(input)
title('original color image')
colormap(gray(256))
subplot(2,1,2)
image(output)
title('detected edges')
truesize

